diff --git a/src/main/java/net/minecraft/core/item/ItemBow.java b/src/main/java/net/minecraft/core/item/ItemBow.java
index e41bf25e9..6df182e85 100644
--- a/src/main/java/net/minecraft/core/item/ItemBow.java
+++ b/src/main/java/net/minecraft/core/item/ItemBow.java
@@ -1,22 +1,18 @@
 
 package net.minecraft.core.item;
 
-import com.mojang.nbt.CompoundTag;
+// Referenced classes of package net.minecraft.src:
+//            Item, EntityPlayer, InventoryPlayer, World, 
+//            EntityArrow, ItemStack
+
 import net.minecraft.core.entity.projectile.EntityArrow;
 import net.minecraft.core.entity.projectile.EntityArrowGolden;
 import net.minecraft.core.entity.projectile.EntityArrowPurple;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.world.World;
 
-import java.util.ArrayList;
-import java.util.Collections;
-import java.util.List;
-
-public class ItemBow
-    extends Item
-    implements IAmmoPickable
+public class ItemBow extends Item
 {
-    protected final List<ItemStack> AMMO_TYPES = new ArrayList<>();
 
     public ItemBow(String name, int id)
     {
@@ -25,112 +21,43 @@ public class ItemBow
         setMaxDamage(384);
     }
 
-    public void addAmmoType(ItemStack stack) {
-        stack.stackSize = 1;
-        for (ItemStack ammoType : AMMO_TYPES) {
-            if (ammoType.isItemEqual(stack)) {
-                return;
-            }
-        }
-        AMMO_TYPES.add(stack);
-    }
-
     @Override
     public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
-        ItemStack ammoType = getPickedAmmoType(itemstack);
-        if (!hasAmmoType(entityplayer, ammoType)) {
-            List<ItemStack> filteredList = getPresentAmmoTypes(entityplayer);
-            if (filteredList.isEmpty()) return itemstack;
-            ammoType = filteredList.get(0);
-            setPickedAmmoType(itemstack, ammoType);
-        }
-
-        if (ammoType.itemID != Item.armorQuiver.id && ammoType.itemID != Item.armorQuiverGold.id) {
-            if (!entityplayer.inventory.consumeInventoryItem(ammoType.itemID)) {
-                return itemstack;
-            }
-        }
-
-        itemstack.damageItem(1, entityplayer);
-        world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
-        if (!world.isClientSide) {
-            handleAmmoFired(ammoType, world, entityplayer);
-        }
-
-        if (ammoType.itemID == Item.armorQuiver.id) {
+        ItemStack quiverSlot = entityplayer.inventory.armorItemInSlot(2);
+        if(quiverSlot != null && quiverSlot.itemID == Item.armorQuiver.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
             entityplayer.inventory.armorItemInSlot(2).damageItem(1, entityplayer);
+            itemstack.damageItem(1, entityplayer);
+            world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
+            if (!world.isClientSide) {
+                world.entityJoinedWorld(new EntityArrow(world, entityplayer, true, 0));
+            }
         }
-
-        return itemstack;
-    }
-
-    private void handleAmmoFired(ItemStack ammoType, World world, EntityPlayer player) {
-        if (ammoType.itemID == Item.ammoArrow.id) {
-            world.entityJoinedWorld(new EntityArrow(world, player, true, 0));
-        } else if (ammoType.itemID == Item.ammoArrowGold.id) {
-            world.entityJoinedWorld(new EntityArrowGolden(world, player, true));
-        } else if (ammoType.itemID == Item.armorQuiver.id) {
-            world.entityJoinedWorld(new EntityArrow(world, player, true, 0));
-        } else if (ammoType.itemID == Item.armorQuiverGold.id) {
-            world.entityJoinedWorld(new EntityArrowPurple(world, player, false));
-        }
-    }
-
-    @Override
-    public boolean hasAmmoType(EntityPlayer player, ItemStack ammoType) {
-        ItemStack quiverSlot = player.inventory.armorItemInSlot(2);
-
-        if (ammoType.itemID == Item.armorQuiver.id) {
-            return quiverSlot != null && quiverSlot.itemID == ammoType.itemID && quiverSlot.getMetadata() < quiverSlot.getMaxDamage();
-        }
-        if (ammoType.itemID == Item.armorQuiverGold.id) {
-            return quiverSlot != null && quiverSlot.itemID == ammoType.itemID;
-        }
-
-        return player.inventory.containsItem(ammoType);
-    }
-
-    @Override
-    public List<ItemStack> getAmmoTypes() {
-        return Collections.unmodifiableList(AMMO_TYPES);
-    }
-
-    @Override
-    public void setPickedAmmoType(ItemStack itemStack, ItemStack ammoType) {
-        CompoundTag tag = itemStack.getData();
-        CompoundTag ammoTag = tag.getCompoundOrDefault("ammo", null);
-        if (ammoTag == null) {
-            ammoTag = new CompoundTag();
-            tag.putCompound("ammo", ammoTag);
+        else if(quiverSlot != null && quiverSlot.itemID == Item.armorQuiverGold.id){
+            itemstack.damageItem(1, entityplayer);
+            world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
+            if (!world.isClientSide) {
+                world.entityJoinedWorld(new EntityArrowPurple(world, entityplayer, false));
+            }
         }
-
-        writeAmmoTypeToTag(ammoType, ammoTag);
-    }
-
-    @Override
-    public ItemStack getPickedAmmoType(ItemStack itemStack) {
-        CompoundTag tag = itemStack.getData();
-        CompoundTag ammoTag = tag.getCompoundOrDefault("ammo", null);
-        if (ammoTag == null) {
-            ammoTag = new CompoundTag();
-            writeAmmoTypeToTag(getDefaultAmmoType(), ammoTag);
-            tag.putCompound("ammo", ammoTag);
+        else if (entityplayer.inventory.consumeInventoryItem(Item.ammoArrowGold.id))
+        {
+            itemstack.damageItem(1, entityplayer);
+            world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
+            if(!world.isClientSide)
+            {
+                world.entityJoinedWorld(new EntityArrowGolden(world, entityplayer, true));
+            }
         }
-
-        short id = ammoTag.getShortOrDefault("id", (short) getDefaultAmmoType().itemID);
-
-        for (ItemStack stack : AMMO_TYPES) {
-            if (stack.itemID == id) {
-                return stack;
+        else if(entityplayer.inventory.consumeInventoryItem(Item.ammoArrow.id))
+        {
+            itemstack.damageItem(1, entityplayer);
+            world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
+            if(!world.isClientSide)
+            {
+                world.entityJoinedWorld(new EntityArrow(world, entityplayer, true, 0));
             }
         }
-
-        return getDefaultAmmoType();
-    }
-
-    private void writeAmmoTypeToTag(ItemStack ammoType, CompoundTag ammoTag) {
-        ammoTag.putShort("id", (short) ammoType.itemID);
+        return itemstack;
     }
-
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemEgg.java b/src/main/java/net/minecraft/core/item/ItemEgg.java
index ce28ed5ee..f75878bd4 100644
--- a/src/main/java/net/minecraft/core/item/ItemEgg.java
+++ b/src/main/java/net/minecraft/core/item/ItemEgg.java
@@ -8,7 +8,11 @@ import net.minecraft.core.entity.projectile.EntityEgg;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.world.World;
 
-public class ItemEgg extends Item
+import java.util.Random;
+
+public class ItemEgg
+    extends Item
+    implements IDispensable
 {
 
     public ItemEgg(String name, int id)
@@ -28,4 +32,11 @@ public class ItemEgg extends Item
         }
         return itemstack;
     }
+
+    @Override
+    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
+        EntityEgg egg = new EntityEgg(world, x, y, z);
+        egg.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+        world.entityJoinedWorld(egg);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java b/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
index f39cd6cc1..13f6cb549 100644
--- a/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
+++ b/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
@@ -1,8 +1,11 @@
 package net.minecraft.core.item;
 
+// Referenced classes of package net.minecraft.src:
+//            Item, EntityPlayer, InventoryPlayer, World,
+//            EntityArrow, ItemStack
+
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.entity.projectile.EntityCannonball;
-import net.minecraft.core.entity.projectile.EntityFireball;
 import net.minecraft.core.world.World;
 
 public class ItemHandCannonLoaded extends Item
@@ -23,7 +26,7 @@ public class ItemHandCannonLoaded extends Item
 		if(!world.isClientSide)
 		{
 			itemstack.damageItem(1, entityplayer);
-			handleAmmoFired(getAmmoType(itemstack), world, entityplayer);
+			world.entityJoinedWorld(new EntityCannonball(world, entityplayer));
 			if(itemstack.stackSize <= 0) {
 				return null;
 			}
@@ -31,14 +34,4 @@ public class ItemHandCannonLoaded extends Item
 		}
         return itemstack;
     }
-
-	private ItemStack getAmmoType(ItemStack itemStack) {
-		return ((IAmmoPickable) Item.handcannonUnloaded).getPickedAmmoType(itemStack);
-	}
-
-	private void handleAmmoFired(ItemStack ammoType, World world, EntityPlayer player) {
-		if (ammoType.itemID == Item.ammoChargeExplosive.id) {
-			world.entityJoinedWorld(new EntityCannonball(world, player));
-		}
-	}
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java b/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java
index dcdb46749..9319f67e6 100644
--- a/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java
+++ b/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java
@@ -1,18 +1,14 @@
 package net.minecraft.core.item;
 
-import com.mojang.nbt.CompoundTag;
+// Referenced classes of package net.minecraft.src:
+//            Item, EntityPlayer, InventoryPlayer, World,
+//            EntityArrow, ItemStack
+
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.world.World;
 
-import java.util.ArrayList;
-import java.util.Collections;
-import java.util.List;
-
-public class ItemHandCannonUnloaded
-    extends Item
-    implements IAmmoPickable
+public class ItemHandCannonUnloaded extends Item
 {
-    private final List<ItemStack> AMMO_TYPES = new ArrayList<>();
 
     public ItemHandCannonUnloaded(String name, int id)
     {
@@ -21,79 +17,14 @@ public class ItemHandCannonUnloaded
         maxStackSize = 1;
     }
 
-    public void addAmmoType(ItemStack stack) {
-        stack.stackSize = 1;
-        for (ItemStack ammoType : AMMO_TYPES) {
-            if (ammoType.isItemEqual(stack)) {
-                return;
-            }
-        }
-        AMMO_TYPES.add(stack);
-    }
-
-    @Override
-    public CompoundTag getDefaultTag() {
-        CompoundTag tag = super.getDefaultTag();
-        CompoundTag ammoTag = new CompoundTag();
-        writeAmmoTypeToTag(getDefaultAmmoType(), ammoTag);
-        tag.putCompound("ammo", ammoTag);
-
-        return tag;
-    }
-
     @Override
     public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
-        ItemStack ammoType = getPickedAmmoType(itemstack);
-        if (entityplayer.inventory.consumeInventoryItem(ammoType.itemID))
+        if (entityplayer.inventory.consumeInventoryItem(Item.ammoChargeExplosive.id))
         {
             world.playSoundAtEntity(entityplayer, entityplayer, "random.click", 1.0F, 1.9F / (itemRand.nextFloat() * 0.2F + 0.4F));
             return new ItemStack(Item.handcannonLoaded, 1, itemstack.getMetadata(), itemstack.getData());
         }
         return itemstack;
     }
-
-    @Override
-    public List<ItemStack> getAmmoTypes() {
-        return Collections.unmodifiableList(AMMO_TYPES);
-    }
-
-    @Override
-    public void setPickedAmmoType(ItemStack itemStack, ItemStack ammoType) {
-        CompoundTag tag = itemStack.getData();
-        CompoundTag ammoTag = tag.getCompoundOrDefault("ammo", null);
-        if (ammoTag == null) {
-            ammoTag = new CompoundTag();
-            tag.putCompound("ammo", ammoTag);
-        }
-
-        writeAmmoTypeToTag(ammoType, ammoTag);
-    }
-
-    @Override
-    public ItemStack getPickedAmmoType(ItemStack itemStack) {
-        CompoundTag tag = itemStack.getData();
-        CompoundTag ammoTag = tag.getCompoundOrDefault("ammo", null);
-        if (ammoTag == null) {
-            ammoTag = new CompoundTag();
-            writeAmmoTypeToTag(getDefaultAmmoType(), ammoTag);
-            tag.putCompound("ammo", ammoTag);
-        }
-
-        short id = ammoTag.getShortOrDefault("id", (short) getDefaultAmmoType().itemID);
-        short damage = ammoTag.getShortOrDefault("Damage", (short) getDefaultAmmoType().getMetadata());
-
-        for (ItemStack stack : AMMO_TYPES) {
-            if (stack.itemID == id && stack.getMetadata() == damage) {
-                return stack;
-            }
-        }
-
-        return getDefaultAmmoType();
-    }
-
-    private void writeAmmoTypeToTag(ItemStack ammoType, CompoundTag ammoTag) {
-        ammoTag.putShort("id", (short) ammoType.itemID);
-        ammoTag.putShort("Damage", (short) ammoType.getMetadata());
-    }
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemPebble.java b/src/main/java/net/minecraft/core/item/ItemPebble.java
index b81b45b0e..cb2ce19f0 100644
--- a/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -14,7 +14,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
-public class ItemPebble extends Item
+import java.util.Random;
+
+public class ItemPebble
+    extends Item
+    implements IDispensable
 {
 
     public ItemPebble(String name, int id)
@@ -23,6 +27,8 @@ public class ItemPebble extends Item
         maxStackSize = 64;
     }
 
+
+
     @Override
     public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
@@ -121,4 +127,11 @@ public class ItemPebble extends Item
         return false;
 
     }
+
+    @Override
+    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
+        EntityPebble pebble = new EntityPebble(world, x, y, z);
+        pebble.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+        world.entityJoinedWorld(pebble);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemSnowball.java b/src/main/java/net/minecraft/core/item/ItemSnowball.java
index 01658a163..ccc94d892 100644
--- a/src/main/java/net/minecraft/core/item/ItemSnowball.java
+++ b/src/main/java/net/minecraft/core/item/ItemSnowball.java
@@ -8,7 +8,11 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.entity.projectile.EntitySnowball;
 import net.minecraft.core.world.World;
 
-public class ItemSnowball extends Item
+import java.util.Random;
+
+public class ItemSnowball
+    extends Item
+    implements IDispensable
 {
 
     public ItemSnowball(String name, int id)
@@ -28,4 +32,11 @@ public class ItemSnowball extends Item
         }
         return itemstack;
     }
+
+    @Override
+    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
+        EntitySnowball entitysnowball = new EntitySnowball(world, x, y, z);
+        entitysnowball.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+        world.entityJoinedWorld(entitysnowball);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemStack.java b/src/main/java/net/minecraft/core/item/ItemStack.java
index ef0d986b6..fb13326c6 100644
--- a/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -367,12 +367,7 @@ public final class ItemStack
 
     public boolean isItemEqual(ItemStack itemstack)
     {
-        if (itemstack == null) return false;
-        boolean idMatches = itemID == itemstack.itemID;
-        if (idMatches && getItem().getHasSubtypes()) {
-            return metadata == itemstack.metadata;
-        }
-        return idMatches;
+        return itemID == itemstack.itemID && metadata == itemstack.metadata;
     }
 
     public String getItemName()
diff --git a/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
index 3b5c1673f..f4f6b6b4c 100644
--- a/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.block.BlockDispenser;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.EntityLiving;
@@ -8,7 +9,12 @@ import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemWandSpawner extends Item{
+import java.util.Random;
+
+public class ItemWandSpawner
+    extends Item
+    implements IDispensable
+{
     public ItemWandSpawner(String name, int id) {
         super(name, id);
     }
@@ -24,6 +30,14 @@ public class ItemWandSpawner extends Item{
         return itemstack;
     }
 
+    private String getEntityId(ItemStack itemStack) {
+        String id = itemStack.getData().getString("monster");
+        if (id == null || id.isEmpty()){
+            id = "Pig";
+        }
+        return id;
+    }
+
     @Override
     public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
@@ -32,11 +46,7 @@ public class ItemWandSpawner extends Item{
             return false;
         }
         if (!world.isClientSide){
-            String id = itemstack.getData().getString("monster");
-            if (id == null || id.isEmpty()){
-                id = "Pig";
-            }
-            Entity entity = EntityDispatcher.createEntityInWorld(id, world);
+            Entity entity = EntityDispatcher.createEntityInWorld(getEntityId(itemstack), world);
             if (entity != null){
                 entity.setPos(blockX + side.getOffsetX() + 0.5f, blockY + side.getOffsetY(), blockZ + side.getOffsetZ() + 0.5f);
                 entity.spawnInit();
@@ -48,4 +58,22 @@ public class ItemWandSpawner extends Item{
         }
         return true;
     }
+
+    @Override
+    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
+        Entity entity = EntityDispatcher.createEntityInWorld(getEntityId(itemStack), world);
+        if (entity != null){
+            entity.setPos(x + xOffset * 0.5, y, z + zOffset * 0.5);
+            entity.spawnInit();
+            if (itemStack.hasCustomName() && entity instanceof EntityLiving){
+                ((EntityLiving)entity).setNickname(itemStack.getCustomName());
+            }
+            world.entityJoinedWorld(entity);
+        }
+    }
+
+    @Override
+    public boolean isRemovedOnDispense() {
+        return false;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java b/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java
index 8a3f9b3a0..108c68288 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java
@@ -1,5 +1,18 @@
 package net.minecraft.core.net.command.commands;
 
+import com.b100.utils.Utils;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.net.command.Command;
+import net.minecraft.core.net.command.CommandError;
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.ReflectionHelper;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
 import java.lang.reflect.Constructor;
 import java.lang.reflect.Parameter;
 import java.util.ArrayList;
@@ -10,18 +23,6 @@ import java.util.Map.Entry;
 import java.util.Random;
 import java.util.Set;
 
-import com.b100.utils.Utils;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.generate.feature.WorldFeature;
-import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.util.helper.ReflectionHelper;
-
 public class GenerateCommand extends Command {
 	
 	private static Map<String, Class<? extends WorldFeature>> worldFeatures = new HashMap<>();
@@ -103,11 +104,20 @@ public class GenerateCommand extends Command {
 			sender.sendMessage("Feature " + worldFeatureClass.getSimpleName() + " requires arguments: ");
 			for(Constructor<?> c : worldFeatureClass.getConstructors()) {
 				StringBuilder argString = new StringBuilder();
-				
+				MethodParametersAnnotation annotation = null;
+				if (c.isAnnotationPresent(MethodParametersAnnotation.class)){
+					annotation = c.getAnnotation(MethodParametersAnnotation.class);
+				}
 				int i=0;
 				for(Parameter parameter : c.getParameters()) {
 					if(i > 0) argString.append(", ");
-					argString.append(parameter.getName()).append(" (").append(parameter.getType().getSimpleName()).append(")");
+					String argname;
+					if (annotation != null && annotation.names().length > i){
+						argname = annotation.names()[i];
+					} else {
+						argname = parameter.getName();
+					}
+					argString.append(argname).append(" (").append(parameter.getType().getSimpleName()).append(")");
 					i++;
 				}
 				
diff --git a/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java b/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
index d59597d4b..4e4b50b8b 100644
--- a/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
+++ b/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
@@ -64,22 +64,6 @@ public class InventoryPlayer
         return -1;
     }
 
-    public boolean containsItem(ItemStack itemStack) {
-        for (ItemStack stack : mainInventory) {
-            if (itemStack.isItemEqual(stack)) {
-                return true;
-            }
-        }
-
-        for (ItemStack stack : armorInventory) {
-            if (itemStack.isItemEqual(stack)) {
-                return true;
-            }
-        }
-
-        return false;
-    }
-
     private int storeItemStack(ItemStack itemstack)
     {
         for(int i = 0; i < mainInventory.length; i++)
diff --git a/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java b/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java
index f04e8a360..15786a4a3 100644
--- a/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java
+++ b/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java
@@ -298,7 +298,6 @@ public class BlockSoundDispatcher
         addDispatch(Block.trapdoorPlanksOakPainted, BlockSounds.WOOD);
         addDispatch(Block.trapdoorIron, BlockSounds.METAL);
         addDispatch(Block.trapdoorGlass, BlockSounds.GLASS);
-        addDispatch(Block.trapdoorGlassTinted, BlockSounds.GLASS);
 
         addDispatch(Block.tnt, BlockSounds.GRASS);
 
@@ -310,8 +309,6 @@ public class BlockSoundDispatcher
         addDispatch(Block.doorPlanksOakPaintedTop, BlockSounds.WOOD);
         addDispatch(Block.doorGlassBottom, BlockSounds.GLASS);
         addDispatch(Block.doorGlassTop, BlockSounds.GLASS);
-        addDispatch(Block.doorGlassTintedBottom, BlockSounds.GLASS);
-        addDispatch(Block.doorGlassTintedTop, BlockSounds.GLASS);
 
         addDispatch(Block.mesh, BlockSounds.METAL);
         addDispatch(Block.meshGold, BlockSounds.METAL);
diff --git a/src/main/java/net/minecraft/core/world/generate/MapGenCaves.java b/src/main/java/net/minecraft/core/world/generate/MapGenCaves.java
index adbe6497c..b681ec06c 100644
--- a/src/main/java/net/minecraft/core/world/generate/MapGenCaves.java
+++ b/src/main/java/net/minecraft/core/world/generate/MapGenCaves.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
@@ -54,7 +55,7 @@ public class MapGenCaves extends MapGenBase
         boolean sharpRotVer = random.nextInt(6) == 0;
         for(; startPos < endPos; startPos++)
         {
-            double width = 1.5D + (double)(MathHelper.sin(((float)startPos * 3.141593F) / (float)endPos) * initialRadius * 1.0F);
+            double width = 1.5D + (MathHelper.sin((startPos * MathHelper.PI) / endPos) * initialRadius * 1.0F);
             double height = width * heightMod;
             float xzScale = MathHelper.cos(rotVer);
             float yOffset = MathHelper.sin(rotVer);
@@ -123,9 +124,9 @@ public class MapGenCaves extends MapGenBase
             {
                 minY = 1;
             }
-            if(maxY > (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) - 8)
+            if(maxY > (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) - (ChunkSection.SECTION_SIZE_Y / 2))
             {
-                maxY = (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) - 8;
+                maxY = (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) - (ChunkSection.SECTION_SIZE_Y / 2);
             }
             if(minZ < 0)
             {
@@ -169,10 +170,10 @@ public class MapGenCaves extends MapGenBase
             // Delete blocks in section
             for(int x = minX; x < maxX; x++)
             {
-                double xPercentage = (((double)(x + baseChunkX * Chunk.CHUNK_SIZE_X) + 0.5D) - blockX) / width;
+                double xPercentage = (((x + baseChunkX * Chunk.CHUNK_SIZE_X) + 0.5D) - blockX) / width;
                 zLabel: for(int z = minZ; z < maxZ; z++)
                 {
-                    double zPercentage = (((double)(z + baseChunkZ * Chunk.CHUNK_SIZE_Z) + 0.5D) - blockZ) / width;
+                    double zPercentage = (((z + baseChunkZ * Chunk.CHUNK_SIZE_Z) + 0.5D) - blockZ) / width;
                     int yIndex = maxY;
                     boolean replaceTopBlock = false;
                     if(xPercentage * xPercentage + zPercentage * zPercentage >= 1.0D)
@@ -186,7 +187,7 @@ public class MapGenCaves extends MapGenBase
                         {
                             continue zLabel;
                         }
-                        double yPercentage = (((double)y + 0.5D) - blockY) / height;
+                        double yPercentage = ((y + 0.5D) - blockY) / height;
                         if(yPercentage > -0.7D && xPercentage * xPercentage + yPercentage * yPercentage + zPercentage * zPercentage < 1.0D)
                         {
                             int blockId = result.getBlock(x, yIndex, z);
@@ -204,17 +205,13 @@ public class MapGenCaves extends MapGenBase
                                     result.setBlock(x, yIndex, z, 0);
                                     
                                     if(replaceTopBlock) {
-                                    	// TODO make this not hardcoded
+                                        Biome biome = worldObj.getBlockBiome(x, yIndex - 1, z);
+                                        int topBlockId = biome.topBlock;
+                                        int fillBlockId = biome.fillerBlock;
                                         int id = result.getBlock(x, yIndex - 1, z);
-                                    	if(id == Block.dirt.id) {
-                                    		if(isAlpha) {
-                                                result.setBlock(x, yIndex - 1, z, Block.grassRetro.id);
-                                    		} else {
-                                                result.setBlock(x, yIndex - 1, z, Block.grass.id);
-                                    		}
-                                    	} else if(id == Block.dirtScorched.id) {
-                                            result.setBlock(x, yIndex - 1, z, Block.grassScorched.id);
-                                    	}
+                                    	if(id == fillBlockId) {
+                                            result.setBlock(x, yIndex - 1, z, topBlockId);
+                                        }
                                     }
                                 }
                             }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/MethodParametersAnnotation.java b/src/main/java/net/minecraft/core/world/generate/feature/MethodParametersAnnotation.java
new file mode 100644
index 000000000..15a0fe44b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/MethodParametersAnnotation.java
@@ -0,0 +1,12 @@
+package net.minecraft.core.world.generate.feature;
+
+import java.lang.annotation.ElementType;
+import java.lang.annotation.Retention;
+import java.lang.annotation.RetentionPolicy;
+import java.lang.annotation.Target;
+
+@Retention(RetentionPolicy.RUNTIME)
+@Target({ElementType.METHOD, ElementType.CONSTRUCTOR})
+public @interface MethodParametersAnnotation {
+    String[] names();
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
index 1676565eb..8e90a8c70 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
@@ -12,12 +12,11 @@ import java.util.Random;
 //            MathHelper
 
 public class WorldFeatureClay extends WorldFeature
-{
-	
-	public WorldFeatureClay(int numberOfBlocks) {
+{	public WorldFeatureClay(int numberOfBlocks) {
 		this(numberOfBlocks, Block.sand);
 	}
 
+    @MethodParametersAnnotation(names = {"numberOfBlocks", "block"})
     public WorldFeatureClay(int numberOfBlocks, Block block)
     {
         clayBlockId = Block.blockClay.id;
